{
//Combine - konverze INI souboru verze 1 na samostatne INI soubory verze 2
// - ulozi kazdou skupinu do samostatneho souboru
// - ikona obsahuje Base64 string ikony
// - vsechny cesty jsou nahrazeny, pokud to jde, promennymi %GGSCRIPTDIR%, ...
}
uses RelToAbsPathUnit;

const OldDir='Combine';
      CombineDir='Combine2';
      Verze='2.0';

var aCmds,aIni:TStringList;

function StrToName(str:string):string;//pokud neni string v uvozovkach a obsahuje nejake pismeno, je to jmeno promenne
begin                                 //vraci string s upravenym jmenem promenne, pokud se tam vyskytuje
  Result:=str;
  if((copy(str,1,1)<>'"') and (RegexFind('(?i)[A-Z_].*',str))) then Result:='%'+str+'%';
  if((copy(Result,1,1)='"')) then Result:=copy(Result,2,length(Result)-2);
end;

function ConvertCmd(sCmd:string):string; //uzavre jmeno promenne do %jemno%
var s,p,p1,p2:string;
begin
  Result:=sCmd;
  s:=sCmd;
  p:=fetch(s,'|');
  p1:=fetch(s,'|');
  p2:=fetch(s,'|');
  if(p='VarTest') then begin
    p1:=StrToName(p1);  //prvni parametr upravit jako jmeno promenne, pokud je to potreba
    p2:=StrToName(p2);  //druhy parametr upravit jako jmeno promenne, pokud je to potreba
    Result:=p+'|'+p1+'|'+p2+'|'+s;
  end;
end;

function ConvertPath(sPath,sType:string):string; //do relativni cesty doplni promennou
var c:string;                                  //zohledni i +/- pred cestou
begin
  Result:=sPath;
  c:=copy(sPath,1,1);
  if(c='+') or (c='-') then sPath:=copy(sPath,2,length(sPath))
  else c:='';
  case sType of
    'GGP': Result:=c+RelToAbsFilename(sPath,'%GG_SCRIPTDIR%');
    'GGE': Result:=c+RelToAbsFilename(sPath,'%GG_SCRIPTDIR%');
    'GGT_SET': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    'GGT_ADD': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    'GGT_SUB': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    'GGF_SET': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    'GGF_ADD': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    'GGF_SUB': Result:=c+RelToAbsFilename(sPath,'%GG_DATADIR%');
    //'GGS':
    //'EXE':
    //'BAT':
    //'CMT':
    'CMD': Result:=c+ConvertCmd(sPath);
    //'ERR':
  end;
end;

procedure SaveCmds(name:string); //ulozi prikazy pro davku name, zaroven provede konverze
var i:Integer;
    c,podm,s,s1,s2:string;
begin
  //napred konverze prikazu
  for i:=0 to aCmds.Count-1 do begin
    s1:=aCmds[i];
    s:=fetch(s1,'=');
    if(s='Icon') then begin //nacteme ikonu a ulozime ji jako Base64
      aCmds[i]:='Icon='+EncodeBase64(FileToString(copy(s1,2,length(s1))));
    end
    else if(s='Comment') then begin //nacteme ikonu a ulozime ji jako Base64
      aCmds[i]:='Comment='+s1;
    end
    else begin    //provedeme nahradu cest za zpromenne
      s:='ERR';
      c:=copy(s1,1,1);
      s1:=copy(s1,2,length(s1));
      podm:=copy(s1,2,length(s1));
      if(podm='+') or (podm='-') then s1:=copy(s1,2,length(s1))
      else podm:='';
        
      case c of
      '@': s:='CMD';
      '-': begin
             c:=lowercase(copy(s1,length(s1)-3,4));
             //ShowMessage('ZZZZ '+IntToStr(i)+':'+s1);
             case c of
             '.ggf': s:='GGF_SUB';
             '.ggt': s:='GGT_SUB';
             end;
           end;
      '+': begin
             c:=lowercase(copy(s1,length(s1)-3,4));
             //ShowMessage('ZZZZ '+IntToStr(i)+':'+s1);
             case c of
             '.ggf': s:='GGF_ADD';
             '.ggt': s:='GGT_ADD';
             end;
           end;
      '/': begin s:='CMT'; s1:=copy(s1,2,length(s1)); end;
      '=': begin
             c:=lowercase(copy(s1,length(s1)-3,4));
             //ShowMessage('ZZZZ '+IntToStr(i)+':'+s1);
             case c of
             '.ggf': s:='GGF_SET';
             '.ggt': s:='GGT_SET';
             end;
           end;
      'G': begin
             c:=lowercase(c+copy(s1,1,3));
             if(c='ggs=') then begin s:='GGS'; fetch(s1,'='); end
             else s1:=copy(c,1,1)+s1;
           end;
      '!': begin
             s2:=fetch(s1,'|');
             c:=lowercase(copy(s2,length(s2)-7,8));
             //ShowMessage('FFFFF'+CRLF+s1+CRLF+c);
             case lowercase(c) of
             '.ggp.pas': s:='GGP';
             '.gge.pas': s:='GGE';
             else begin
               c:=lowercase(copy(s2,length(s2)-3,4));
               case c of
               '.bat': s:='BAT';
               '.exe': s:='EXE';
               else s:='RUN';
               end;
               end;
             end;
             s1:=s2+'|'+s1;
           end;
      else s1:=c+podm+s1;
      end;
      s1:=ReplaceString(s1,GEOGET_SCRIPTDIR,'%GG_SCRIPTDIR%');
      s1:=ReplaceString(s1,GEOGET_DATADIR,'%GG_DATADIR%');
      s1:=ReplaceString(s1,GEOGET_PROGPATH,'%GG_PROGDIR%');
      aCmds[i]:=s+'='+podm+ConvertPath(s1,s);
    end;
  end;
  //doplnime radek se jmenem
  aCmds.Insert(0,'Name='+name);
  s:=GEOGET_SCRIPTDIR+'\Combine2\Batches\'+FilenameFromText(name+'.ini');
  i:=6;
  if(FileExists(s)) then begin
    i:=MessBox('Prevodem skupiny "'+name+'" ma byt vytvoren soubor'+CRLF+CRLF
      +s+CRLF+CRLF
      +'ktery vsak jiz existuje. Ma byt prepsan?','Prepis souboru',4);
  end;
  if(i=6) then begin
    s1:='[Group]'+CRLF;
    for i:=0 to aCmds.Count-1 do begin
      s1:=s1+aCmds[i]+CRLF;
    end;
    StringToFile(s1,s);
  end;
end;

procedure ConvertGroup(ind:Integer);
var i,j:Integer;
    s,sGrp:string;
begin
  aCmds.Clear();
  s:=aIni[ind]; //poradi a jmeno skupiny
  sGrp:=fetch(s,'=');
  //ShowMessage('CCCCC prevod skupiny '+sGrp);
  for i:=ind to aIni.Count-1 do begin   //najdeme zacatek prikazu skupiny
    j:=i+1;
    if(trim(aIni[i])='['+sGrp+']') then i:=aIni.Count-1;
  end;
  //prepiseme vsechny prikazy do aCmd
  for i:=j to aIni.Count-1 do begin
    if(copy(aIni[i],1,1)='[') then i:=aIni.Count-1
    else aCmds.Add(trim(aIni[i]));
  end;
  //pokud je nejaky prikaz, prikazy ulozime
  if(aCmds.Count>0) then SaveCmds(s);
end;

procedure ConvertIniFormat1To2;
var i,j:Integer;
    sFile:string;
begin
  aCmds:=TStringList.Create();
  aIni:=TStringList.Create();
  ForceDirectories(GEOGET_SCRIPTDIR+'\'+CombineDir+'\Batches');
  sFile:=GEOGET_SCRIPTDIR+'\'+OldDir+'\Combine.ini';
  if(FileExists(sFile)) then begin
    aIni.LoadFromFile(sFile);
    //najdeme zacatek sekce se jmeny skupin
    j:=1;
    for i:=0 to aIni.Count-1 do begin
      if(aIni[i]='[Groups]') then i:=aIni.Count-1
      else j:=j+1;
    end;
    //ShowMessage('XXX index seznamu skupin:'+IntToStr(j));
    for i:=j  to aIni.Count-1 do begin //nacteme jmeno kazde skupiny a zpracujeme ji
      if(copy(aIni[i],1,1)='[') then i:=aIni.Count-1 //konec jmen skupin
      else ConvertGroup(i);
    end;
    {
    ShowMessage('Skupiny z Combine.ini (verze 1.x) byly prevedeny do'+CRLF
      +'verze 2.0. Doporucuju zkotrolovat jejich funkcnost a'+CRLF
      +'starou verzi Combine odinstalovat, aby pri aktualizaci'+CRLF
      +'dalsi verze nedoslo k dalsimu prevodu stareho Combine.ini'+CRLF
      +'a tim k prepsani treba jiz v nove verzi pozmenenych skupin.');
    }
    if(aCmds<>nil) then aCmds.Free();
    if(aIni<>nil) then aIni.Free();
{$ifndef GGP_MACRO}
    //upozornit na to, ze stara verze zustava i nadale na disku
    //sFile:=FileToString(GEOGET_SCRIPTDIR+'\'+CombineDir+'\Combine.InstallInfo.txt');
    //ShowLongMessage('Instalace Combine 2',sFile);

    //vymazeme starou verzi, uz je dostatecne overena funkcnost ... (2.0.2.5)
    DeleteFile(sFile);

    //pridame do pluginmanageru skupinu Combine a do ni tento novy script
    sFile:=GEOGET_SCRIPTDIR+'\'+CombineDir+'\Combine.ggp.pas';
    GeoSetToolbar(sFile,true);
    GeoSetPluginGroup(sFile,'Combine 2');

{$endif}
    //pokud existuje stary soubor CombineCommand.ini, smazeme ho
    sFile:=GEOGET_SCRIPTDIR+'\'+CombineDir+'\CombineCommand.ini';
    if(FileExists(sFile)) then DeleteFile(sFile);
  end;
end;

{$ifndef GGP_MACRO}
function InstallWork:string; begin
  ConvertIniFormat1To2();
  Result:='';
end;
{$endif}
