{ Run Shell Wait - spousteni procesu prevzato od Valicka

  RunShellWait(cmd): boolean;
}

const
  CREATE_NEW_PROCESS_GROUP = 512;
  NORMAL_PRIORITY_CLASS = 32;
  STILL_ACTIVE = $103;

type
  TPRocessInformation = record
    hProcess: Cardinal; //Pointer v C, v delphi Cardinal???
    hThread: Cardinal;  //TProcessInformation m tyto dv poloky jako cardinal
    dwProcessId: Cardinal;
    dwThreadId: Cardinal;
  end;
  TStartupInfo = record
    cb: cardinal;
    lpReserved: PChar;
    lpDesktop: PChar;
    lpTitle: Pchar;
    dwX: Cardinal;
    dwY: Cardinal;
    dwXSize: Cardinal;
    dwYSize: Cardinal;
    dwXCountChars: Cardinal;
    dwYCountChars: Cardinal;
    dwFillAttribute: Cardinal;
    dwFlags: Cardinal;
    wShowWindow: word;
    cbReserved2: word;
    lpReserved2: PChar; //PByte
    hStdInput: Cardinal; //jako u TProcessInformation
    hStdOutput: Cardinal;
    hStdError: Cardinal;
  end;
  //deklarace funkci z Win knihoven
  function CreateProcess(lpApplicationName: PChar; lpCommandLine: PChar; lpProcessAttributes, lpThreadAttributes: {PSecurityAttributes}PCHar; bInheritHandles: Boolean; dwCreationFlags: Cardinal; lpEnvironment: Cardinal; lpCurrentDirectory: PChar;
    const lpStartupInfo: TStartupInfo; var lpProcessInformation: TProcessInformation): boolean; external 'CreateProcessA@kernel32 stdcall';
  function WaitForSingleObject(hHandle:Cardinal; dwMilliseconds:Cardinal):Cardinal; external 'WaitForSingleObject@kernel32 stdcall';
  function GetExitCodeProcess(hProcess: Cardinal; var lpExitCode: Cardinal): boolean; external 'GetExitCodeProcess@kernel32 stdcall';

function RunShellWait(CmdLine:string):boolean;
var
  //start, konec: longword;
  SI: TSTartupInfo;
  PI: TProcessInformation;
  spusteno: boolean;
  ExitCode:  cardinal;
  s:string;
begin
  //start:=GetTick();
  s:='cmd.exe /C '+CmdLine;
  //s:='g:\Tmp\nejake.jpg';    //takto to nejde
  //s:='cmd.exe /C g:\Tmp\nejake.jpg';  //ale takto ano!
  //s:=GEOGET_DATADIR + '\script\geojarry\geojarryw.exe';
  spusteno:=CreateProcess('',       //nazev aplikace
    PChar(s),             //prikaz vcetne parametru!
    '', '',               //atributy procesu a threadu, nelze jednodue implentovat, proto nil
    False,                //zdedit handle po rodicovsk aplikaci
    CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS, //parametry spusteni
    0,                    //pointer na nove prostredi
    '',                   //adresar spousteni (v tomto pripade adresar bude GG)
    SI, PI);

  //v pripade Win proces spustime, a budeme cekat,
  //v pripade Linuxu zobrazime dialig, ktermy uzivatel potvrdi dokonceni
  if(not spusteno) then begin
    Result:=false;
    exit;
  end;
{$ifdef WINE}
  //ve Wine nejde cekat na dokonceni procesu, proto zobrazime okno a uzivatel
  //odklikne pokracovani po dokonceni procesu rucne
   ShowMessage(_('Click OK to continue.'));
{$else}
  if(spusteno) then begin
    if(pi.hProcess>0) then begin
      ExitCode:=Still_Active;
      while(ExitCode=Still_Active) do begin
        WaitForSingleObject(pi.hProcess,500);
        GetExitCodeProcess(pi.hProcess,ExitCode);
      end;
    end;
    Result:=true;
    //konec:=GetTick;
  end;
{$endif}
  //ShowMessage('Trvn: ' + IntToStr(konec-start) + ' ms');
end;
